//************************************************************************************
// Copyright (c) 2006, Olivier ROCH VILATO, Chew Keong TAN
// All rights reserved.
//
// Win32/Linux Coding by Chew Keong TAN and Olivier ROCH VILATO
//
// This file is part of DrKnock (based on sig2knock).

// DrKnock is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// DrKnock is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with DrKnock; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//************************************************************************************

#ifndef _CLIENTPROCESSPKT_
#define _CLIENTPROCESSPKT_

#include "packetTypes.h"

int getPaddedSize(int size);
char *padAndEncrypt(char *userID, unsigned char *userPasswordHash, char *data, int size, int *outSize);
//void generateKnockSequence(PORTSEQ_REQ *pq, char *userID, unsigned char *userPasswordHash);
void generateKnockSequence(PORTSEQ_REQ *pq, PORTSEQ_REQ *netorder_pq, 
						   char *userID, unsigned char *userPasswordHash);
	

char *makePortSeqReqPkt(char *userID, int userIDSize, char *paddedPq, int size, int *outSize);
//void generateKnockResultQuery(PORTREQ_QUERY *prc, char *userID, unsigned char *userPasswordHash, 
//							  DWORD prevTimeStamp);
void generateKnockResultQuery(PORTREQ_QUERY *prc, PORTREQ_QUERY *netorder_prc, 
							  char *userID, unsigned char *userPasswordHash, 
							  DWORD prevTimeStamp);

unsigned int calculate_checksum(unsigned short* addr, int count);
BOOL sendSYNKnockPacket(SOCKET s_send, DWORD srcIP, DWORD destIP, DWORD ISN, WORD port);
BOOL doSYNPortKnock(char *destIP, PORTSEQ_REQ *pq);
BOOL doUDPPortKnock(char *destIP, PORTSEQ_REQ *pq, char *userID, unsigned char *userPasswordHash);
SOCKET getUDPConnection(char *destIP, WORD destPort, WORD srcPort);
BOOL doUDPPortKnockReq(char *destIP, WORD destPort, PORTSEQ_REQ *pq, char *userID, 
					   unsigned char *userPasswordHash);
BOOL decryptUDPReply(char *udpData, int size, char *userID, unsigned char *userPasswordHash, 
					 uint32_t timeStamp, WORD *outAllocPort, WORD *outPortOpenTime, WORD *outReqType);
BOOL doUDPPortKnockQuery(char *destIP, WORD destPort, PORTREQ_QUERY *prq, 
						 PORTREQ_QUERY *netorder_prq, char *userID, 
						 unsigned char *userPasswordHash, 
						 WORD *outAllocPort, WORD *outPortTime, WORD *outReqType);
#if !defined(WIN32)
BOOL getOutInterfaceIP(DWORD destIP, DWORD *outIfIP);
BOOL createRawSendSocket(void);
#endif
#endif
