//************************************************************************************
// Copyright (c) 2006, Olivier ROCH VILATO, Chew Keong TAN
// All rights reserved.
//
// Win32/Linux Coding by Chew Keong TAN and Olivier ROCH VILATO
//
// This file is part of DrKnock (based on sig2knock).

// DrKnock is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// DrKnock is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with DrKnock; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//************************************************************************************

#ifndef _FIREWALL_SUPPORT_
#define _FIREWALL_SUPPORT_
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <netinet/in.h>
#include <limits.h>
#include <netdb.h>
#include <arpa/inet.h>
#include <pthread.h>
#include "windowsdef.h"

#define OPEN_FW		1
#define CLOSE_FW	2


typedef struct _FIREWALL_SUPPORT_
{
	WORD type;			// OPEN_FW, CLOSE_FW
	DWORD allowedIP;
	WORD portNum;
} FIREWALL_SUPPORT;


BOOL fwOpenFirewall(DWORD trustedIP, WORD allocPort);
BOOL fwCloseFirewall(DWORD trustedIP, WORD allocPort);
void startFwSupport(void);
void fwCloseALL(void);
void endFwSupport(void);
BOOL auxCloseFirewall(DWORD trustedIP, WORD allocPort);
BOOL auxOpenFirewall(DWORD trustedIP, WORD allocPort);
BOOL fwCloseListFunc(LPVOID data, LPVOID toFind);
	
#endif
