//************************************************************************************
// Copyright (c) 2006, Olivier ROCH VILATO, Chew Keong TAN
// All rights reserved.
//
// Win32/Linux Coding by Chew Keong TAN and Olivier ROCH VILATO
//
// This file is part of DrKnock (based on sig2knock).

// DrKnock is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// DrKnock is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with DrKnock; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//************************************************************************************

#ifndef _PLATFORMSPECFUNC_H_
#define _PLATFORMSPECFUNC_H_

#include <stdio.h>
#include <stdint.h>
#include <time.h>
#if defined(WIN32)
  #include <windows.h>
  #include <winsock2.h>
  #include <ws2tcpip.h>
#else
  #include "windowsdef.h"
  #include <stdlib.h>
  #include <string.h>
  #include <sys/types.h>
  #include <sys/socket.h>
  #include <sys/ioctl.h>
  #include <errno.h>
  #include <unistd.h>
  #include <fcntl.h>
  #include <netinet/in.h>
  #include <limits.h>
  #include <netdb.h>
  #include <arpa/inet.h>
#endif


#if defined(WIN32)
    typedef SOCKET dk_socket_t;
#else
    typedef int dk_socket_t;
#endif

void dk_closesocket(dk_socket_t sock);
void dk_sleep(unsigned int sleeptime);
uint32_t dk_ipaddr(struct in_addr *addr);
void dk_setaddr(struct in_addr *saddr,uint32_t addr);
#endif
