//************************************************************************************
// Copyright (c) 2006, Olivier ROCH VILATO, Chew Keong TAN
// All rights reserved.
//
// Win32/Linux Coding by Chew Keong TAN and Olivier ROCH VILATO
//
// This file is part of DrKnock (based on sig2knock).

// DrKnock is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// DrKnock is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with DrKnock; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//************************************************************************************

#ifndef _PORTSEQREQLIST_
#define _PORTSEQREQLIST_
#if !defined(WIN32)
  #include "windowsdef.h"
#endif

typedef struct _LINKED_LIST_NODE
{
	struct _LINKED_LIST_NODE *prev;
	struct _LINKED_LIST_NODE *next;
	LPVOID data;
} LINKED_LIST_NODE;


typedef struct _LINKED_LIST
{
	LINKED_LIST_NODE *head;
	LINKED_LIST_NODE *tail;
} LINKED_LIST;


typedef void (*PRINT_ITEM_FUNC)(LPVOID data);
typedef BOOL (*FIND_ITEM_FUNC)(LPVOID data, LPVOID toFind);
typedef BOOL (*PROCESS_ITEM_FUNC)(LPVOID portSeqReqRec, LPVOID procData);

void initList(LINKED_LIST *list);
BOOL insertItem(LINKED_LIST *list, LPVOID data);
void printList(LINKED_LIST *list, PRINT_ITEM_FUNC pi);
LPVOID findItem(LINKED_LIST *list, FIND_ITEM_FUNC fi, LPVOID toFind);
LPVOID deleteSingleItem(LINKED_LIST *list, FIND_ITEM_FUNC fi, LPVOID toDelete);
int deleteMultipleItems(LINKED_LIST *list, FIND_ITEM_FUNC fi, LPVOID toDelete);
void printListBackwards(LINKED_LIST *list, PRINT_ITEM_FUNC pi);
BOOL processSingleItem(LINKED_LIST *list, PROCESS_ITEM_FUNC pi, LPVOID procData);
void processMultipleItems(LINKED_LIST *list, PROCESS_ITEM_FUNC pi, LPVOID procData);

#endif
