//************************************************************************************
// Copyright (c) 2006, Olivier ROCH VILATO, Chew Keong TAN
// All rights reserved.
//
// Win32/Linux Coding by Chew Keong TAN and Olivier ROCH VILATO
//
// This file is part of DrKnock (based on sig2knock).

// DrKnock is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// DrKnock is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with DrKnock; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//************************************************************************************

#ifndef _PRIV_PROC_SUPPORT_
#define _PRIV_PROC_SUPPORT_
#include "windowsdef.h"
#include "userRecord.h"

#define OPEN_FW         	1
#define CLOSE_FW        	2
#define GETUSER			3
#define GETUSER_REPLY		4
#define SAVEUSER		5
#define SAVEUSER_REPLY		6
#define SEND_UDPDATA		7
#define SEND_UDPDATA_OK		8
#define SEND_UDPDATA_NOTOK	9
#define WRITE_SYSLOG		10

#define MAX_UDP_DATA		200
#define MAX_LOG_LEN		200

typedef struct _PRIVPROC_SUPPORT
{
	WORD type;                      // OPEN_FW, CLOSE_FW, etc

	// open/close FW params
	union
	{
		struct _FW_PARAMS
		{
			DWORD allowedIP;
			WORD portNum;
		} fwParams;

		struct _UDP_SEND
		{
			DWORD destIP;
			WORD destPort;
			WORD localPort;
			DWORD pktSize;
			unsigned char data[MAX_UDP_DATA];		// allow max 200 bytes
		} udpSendParams;

		struct _SYS_LOGGING
		{
			char logStr[MAX_LOG_LEN+1];
		} syslogParams;

		USER_RECORD userRecord;
	} data;

} PRIVPROC_SUPPORT;

void initPrivProcSupport(void);
void startPrivProcSupport(void);
void psLowerPrivClosePipes(void);
BOOL psGetUserRecord(char *userName, USER_RECORD *userRec);
LPVOID privProcThreadFunc(LPVOID data);
BOOL psUpdateUserTimestamp(char *userName, DWORD newTimestamp);
BOOL psCloseFirewall(DWORD trustedIP, WORD allocPort);
BOOL psOpenFirewall(DWORD trustedIP, WORD allocPort);
BOOL psSendUDPReply(DWORD destIP, WORD destPort, WORD srcPort, char *reply, DWORD pktSize);	

#endif
