//************************************************************************************
// Copyright (c) 2006, Olivier ROCH VILATO, Chew Keong TAN
// All rights reserved.
//
// Win32/Linux Coding by Chew Keong TAN and Olivier ROCH VILATO
//
// This file is part of DrKnock (based on sig2knock).

// DrKnock is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// DrKnock is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with DrKnock; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//************************************************************************************

#ifndef _SERVERPROCESSPKT_
#define _SERVERPROCESSPKT_

#include "userRecord.h"
#include "portSeqReqList.h"

#include "packetTypes.h"

#define ETH2_HEADER_SIZE		14

typedef struct __attribute__((packed)) _ETH2_HEADER
{
	char destMAC[6];
	char srcMAC[6];
	unsigned short pktType;
} ETH2_HEADER;



unsigned int calculate_checksum(unsigned short* addr, int count);
int getPaddedSize(int size);
BOOL decryptUDPReq(char *requestData, int size,
				   char **userid, LPVOID *decPktData, 
				   unsigned short int *pktType);

LPVOID getUDPData(char *pkt, int size, struct in_addr *serverIPAddr, 
				  IP_HEADER **out_iphdr, UDP_HEADER **out_udphdr, int *outDataSize);

BOOL getTCPKnockData(char *pkt, int size, struct in_addr *serverIPAddr,
					 DWORD *ISN, WORD *port, struct in_addr *srcIP);

DWORD getIPPktType(char *pkt, int size);
DWORD getIPSrcAddr(char *pkt, int size);
LPVOID getIPHeader(char *packet, int size, int *outIPPktLen);
WORD getUDPSrcPort(char *pkt, int size);

typedef struct _PORTREQ_QUERY_REC
{
	PORTREQ_QUERY prq;
	char userID[SIZEOF_USERID];
	DWORD clientIP;
	WORD clientPort;
} PORTREQ_QUERY_REC;


typedef struct _PORTSEQ_REQREC
{
	DWORD clientIP;
	DWORD clientInternalIP;
	WORD ports[MAX_KNOCKS];
	DWORD ISNs[MAX_KNOCKS];
	uint32_t timeStamp;
	WORD nextKnock;			// next expected knock 0, 1 or 2
	char userID[SIZEOF_USERID];
	WORD portAllocated;
	DWORD insertTime;		// time this record has inserted time(NULL)
	WORD reqType;			// single/multiple connections
	WORD replyCount;	// counts the number of times we have replied to the client to prevent DoS
} PORTSEQ_REQREC;


BOOL sendPortSeqQueryReply(DWORD clientIP, WORD clientPort, uint32_t timeStamp, char *userID,
						   unsigned char *userPasswordHash, WORD allocPort, WORD reqType);

char *padAndEncrypt(char *userID, unsigned char *userPasswordHash, char *data, int size, int *outSize);

char *makePortSeqQueryReplyPkt(WORD allocPort, uint32_t timeStamp, char *userID, 
							   unsigned char *userPasswordHash, WORD reqType, int *outPktSize);

#endif
