//************************************************************************************
// Copyright (c) 2006, Olivier ROCH VILATO, Chew Keong TAN
// All rights reserved.
//
// Win32/Linux Coding by Chew Keong TAN and Olivier ROCH VILATO
//
// This file is part of DrKnock (based on sig2knock).

// DrKnock is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// DrKnock is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with DrKnock; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//************************************************************************************

#if defined(WIN32)
  #include <windows.h>
#else
  #include "windowsdef.h"
#endif

#include "stdio.h"
#include "base64.h"
#include "md5.h"
#include "version.h"

#if !defined(WIN32)
  #include <stdlib.h>
  #include <string.h>
  #include <unistd.h>
  #include <termios.h>
  #include "unix/useradd_unix.cpp"
#else
  #include "win32/useradd_win32.cpp"
#endif




//************************************************************************************
// Generates user's password hash for user account file (user.txt)
//
//************************************************************************************

int main(int argc, char* argv[])
{
	char userID[9];
	char password[17];

	printf("Dr Knock Version %s 2006\n"
		   "Linux/win32 Coding by Olivier ROCH VILATO and Chew Keong TAN\n\n", PROG_VERSION);

	getUserIDPassword(userID, sizeof(userID), password, sizeof(password));

	MD5Context ctx;
	MD5Init(&ctx);
	MD5Update(&ctx, (unsigned char *)userID, strlen(userID));
	MD5Update(&ctx, (unsigned char *)password, strlen(password));

	md5byte digest[16];
	MD5Final(digest, &ctx);

	unsigned char base64Output[25];
	memset(base64Output, 0, sizeof(base64Output));
	B64Encode(digest, 16, base64Output);

	memset(password, 0, sizeof(password));

	printf("\n\nAdd the following line to the user account file.\n");
	printf("\n%s:%s:0\n\n\n", userID, base64Output);

	return 0;
}

