//************************************************************************************
// Copyright (c) 2006, Olivier ROCH VILATO, Chew Keong TAN
// All rights reserved.
//
// Win32/Linux Coding by Chew Keong TAN and Olivier ROCH VILATO
//
// This file is part of DrKnock (based on sig2knock).

// DrKnock is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// DrKnock is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with DrKnock; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//************************************************************************************
extern short int           clientPortLow;
extern short int           clientPortHigh;

#if !defined(WIN32)
  #include "unix/portForward_unix.cpp"
#else
  #include "win32/portForward_win32.cpp"
#endif


//************************************************************************************
// Looks for random port number and binds to it.
//
//************************************************************************************

SOCKET bindFreePort(DWORD allowedIP, WORD *outPortNum)
{
    int range;
    
    if ((!clientPortHigh)&&(!clientPortLow))
    {
          range=65535;
    }
    else
    {
          range=clientPortHigh-clientPortLow;
    }
    
	for(int i = 0; i < 10; i++)		// 10 tries
	{
		WORD curPort = getRandWORD();

        curPort=(WORD) (clientPortLow+(range*curPort)/65535);
		struct sockaddr_in sin;
		#if defined(WIN32)
		SOCKET s = WSASocket(AF_INET, SOCK_STREAM, 0, NULL, 0, 0);
		#else
		SOCKET s = socket(AF_INET, SOCK_STREAM, 0);
		#endif

		if(s == INVALID_SOCKET)
			return INVALID_SOCKET;

		sin.sin_addr.s_addr = 0;
		sin.sin_family = AF_INET;
		sin.sin_port = htons(curPort);
        #if defined(WIN32)
		if(bind(s, (SOCKADDR *)&sin, sizeof(sin)) == 0)
		#else
		if(bind(s, (struct sockaddr *)&sin, sizeof(sin)) == 0)
		#endif
		{
			if(listen(s, 2) == 0)
			{
				*outPortNum = curPort;				
				return s;
			}
		}
		#if defined(WIN32)
		closesocket(s);
		#else
		close(s);
		#endif
	}
	struct in_addr ina;
	#if defined(WIN32)
	ina.S_un.S_addr = allowedIP;
	#else
	ina.s_addr = allowedIP;
	#endif

	logString("Cannot find free port for %s\n", inet_ntoa(ina));
	return INVALID_SOCKET;
}
//************************************************************************************
