//************************************************************************************
// Copyright (c) 2006, Olivier ROCH VILATO, Chew Keong TAN
// All rights reserved.
//
// Win32/Linux Coding by Chew Keong TAN and Olivier ROCH VILATO
//
// This file is part of DrKnock (based on sig2knock).

// DrKnock is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// DrKnock is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with DrKnock; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//************************************************************************************


void getUserIDPassword(char *userID, int userIDSize, char *password, int passwordSize)
{
	struct termios origFlags, newFlags;
	char *userNamePrompt = "New User Name: ";
	char *userPasswordPrompt = "New Password: ";


	memset(userID, 0, userIDSize);
	write(1, userNamePrompt, strlen(userNamePrompt));
	read(0, userID, userIDSize - 1);

	userID[userIDSize - 1] = 0;
	int i;
	for(i = userIDSize - 1; i >= 0; i--)
	{
		if(userID[i] == 0x0a || userID[i] == 0x0d)
			userID[i] = 0;
	}

	// turn off echo
	tcgetattr(0, &origFlags);

	newFlags = origFlags;
	newFlags.c_lflag &= ~(ECHO | ECHOE | ECHOK | ECHONL | ECHOCTL | ECHOPRT | ECHOKE);

	tcsetattr(0, TCSANOW, &newFlags);

	// clear the buffer
	fd_set fset;
	FD_ZERO(&fset);
	FD_SET(0, &fset);
	struct timeval tv;
	tv.tv_sec = 1;
	tv.tv_usec = 0;
	int status = select(1, &fset, NULL, NULL, &tv);
	
	if(status)
	{
		char buffer[1024];
	        read(0, buffer, sizeof(buffer));
	}
	                                                                                                                 
	
	memset(password, 0, sizeof(password));	
	write(1, userPasswordPrompt, strlen(userPasswordPrompt));	
	read(0, password, passwordSize - 1);


	password[passwordSize - 1] = 0;
	for(i = passwordSize - 1; i >= 0; i--)
	{
		if(password[i] == 0x0a || password[i] == 0x0d)
			password[i] = 0;
	}
					
	// turn on echo
	tcsetattr(0, TCSANOW, &origFlags);
}


