//************************************************************************************
// Copyright (c) 2006, Olivier ROCH VILATO, Chew Keong TAN
// All rights reserved.
//
// Win32/Linux Coding by Chew Keong TAN and Olivier ROCH VILATO
//
// This file is part of DrKnock (based on sig2knock).

// DrKnock is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.

// DrKnock is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with DrKnock; if not, write to the Free Software
// Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
//************************************************************************************

//************************************************************************************
// Sends a P3 packet back to client.
//
//************************************************************************************

BOOL sendPortSeqQueryReply(DWORD clientIP, WORD clientPort, uint32_t timeStamp, char *userID,
						   unsigned char *userPasswordHash, WORD allocPort, WORD reqType)
{
	SOCKET sock;
	//****************************** Send PortSeq Request PKT ****************************/
    sock = socket(AF_INET, SOCK_DGRAM, 0);
    if(sock == INVALID_SOCKET)
    {
		logString("Error: UDP socket creation failed: %d\n", WSAGetLastError());
		return FALSE;
	}
	
	struct sockaddr_in dest;
	dest.sin_family = AF_INET;
	dest.sin_port = htons(clientPort);
	dest.sin_addr.s_addr = clientIP;

	struct sockaddr_in local;
    local.sin_family = AF_INET;
    local.sin_port = htons(getConfigUDPPort());
    local.sin_addr.s_addr = htonl(INADDR_ANY);
		
    if(bind(sock, (struct sockaddr *)&local, sizeof(local)) == SOCKET_ERROR)
    {
		logString("Error: UDP socket bind() failed!\n");
		closesocket(sock);		
		return FALSE;
	}

	if(connect(sock, (struct sockaddr *)&dest, sizeof(dest)) == SOCKET_ERROR)
	{
		logString("Error: UDP connect() failed!\n");
		closesocket(sock);		
		return FALSE;
	}

	int pktSize;
	char *reply = makePortSeqQueryReplyPkt(allocPort, timeStamp, 
		                                   userID, userPasswordHash, 
										   reqType, &pktSize);
	if(reply)
	{
		for(int i = 0; i < NUM_PARANOID_RESENT; i++)
		{
			if(send(sock, reply, pktSize, 0) == SOCKET_ERROR)
			{
				logString("Error: UDP send() failed!\n");
				closesocket(sock);		
				return FALSE;
			}
		}
		free(reply);
	}
	else
	{
		closesocket(sock);
		return FALSE;
	}

	closesocket(sock);
	return TRUE;
}

